﻿using System;
using System.Diagnostics;
using System.Windows.Forms;

namespace TestEscape
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1TextBox1.Value = "ABC";

            c1TextBox1.PreviewKeyDown += C1TextBox1_PreviewKeyDown;
        }

        bool _isModifiedBefore = false;

        private void C1TextBox1_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                _isModifiedBefore = c1TextBox1.Modified;
            }
        }

        protected override bool ProcessDialogKey(Keys keyData)
        {
            if (keyData == Keys.Escape && !_isModifiedBefore)
            {
                Debug.WriteLine(c1TextBox1.Value);
                Close();
            }

            return base.ProcessDialogKey(keyData);
        }
    }
}
